"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const node_hid_1 = __importDefault(require("node-hid"));
const headphone_list_1 = __importDefault(require("./headphone_list"));
const build_simple_headphones_1 = __importDefault(require("./use_cases/build_simple_headphones"));
const report_1 = __importDefault(require("./use_cases/report"));
class ArctisUsbFinder {
    constructor() {
        this.devices = [];
    }
    simpleHeadphones() {
        const simpleBuilder = new build_simple_headphones_1.default();
        return simpleBuilder.execute(this.devices);
    }
    loadHeadphones() {
        this.findHeadphones();
        this.devices.map(report_1.default);
    }
    refreshHeadphones() {
        this.devices.map(report_1.default);
    }
    findHeadphones() {
        const hidDevices = node_hid_1.default.devices();
        this.devices = hidDevices
            .map((hidDevice) => {
            return {
                hidDevice,
                report: [],
                headphone: headphone_list_1.default.find((headphone) => {
                    const result = hidDevice.vendorId === headphone.vendorId && hidDevice.productId === headphone.productId;
                    if (result === false)
                        return false;
                    if (headphone.usagePage !== 0 && headphone.usage !== 0) {
                        return (hidDevice.usagePage === headphone.usagePage &&
                            hidDevice.usage === headphone.usage &&
                            hidDevice.interface === headphone.interfaceNum);
                    }
                    return hidDevice.interface === headphone.interfaceNum;
                }),
            };
        })
            .filter((hash) => {
            if (hash.headphone) {
                hash.headphone.path = hash.hidDevice.path;
                return true;
            }
        });
        return this.devices;
    }
}
exports.default = ArctisUsbFinder;
