"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const battery_helpers_1 = require("../../utils/battery_helpers");
class Arctis9MapBatteryBuilder {
    execute(report, knownHeadphone) {
        if (report.length === 0) {
            return { isConnected: false };
        }
        const batteryPercent = (0, battery_helpers_1.calculateBattery)(report[knownHeadphone.batteryPercentIdx], 0x64, 0x9a);
        const isConnected = true;
        let isCharging;
        let isDischarging;
        if (knownHeadphone.chargingStatusIdx) {
            if (report[knownHeadphone.chargingStatusIdx]) {
                isCharging = true;
                isDischarging = false;
            }
            else {
                isCharging = false;
                isDischarging = true;
            }
        }
        return { batteryPercent, isConnected, isCharging, isDischarging };
    }
}
exports.default = Arctis9MapBatteryBuilder;
